package domain;

import java.io.Serializable;
import java.util.Vector;

public class Owner implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String bankAccount = "";
	private String name = "";
	private String mailAccount = "";
	private Vector<RuralHouse> ruralHouses;


	public Owner(String name, String bankAccount,String mail) {
		this.bankAccount = bankAccount;
		this.name = name;
		this.mailAccount = mail;
		ruralHouses = new Vector<RuralHouse>();
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getBankAccount() {
		return this.bankAccount;
	}

	public void setBankAccount(String bankAccount) {
		this.bankAccount = bankAccount;
	}

	public Vector<RuralHouse> getRuralHouses(){
		return this.ruralHouses;
	}



	public RuralHouse addRuralHouse(String houseName, String description,
			String town, int nRooms, int nKitchens, int nBaths, int nLivings,
			int nParkings) {
		HouseFeatures feature = new HouseFeatures(nRooms, nKitchens, nBaths, nLivings, nParkings);
		RuralHouse rh = new RuralHouse(houseName, this, description, town,feature);
		ruralHouses.add(rh);
		return rh;
	}
	
	public RuralHouse addRuralHouse(RuralHouse rh) {
		ruralHouses.add(rh);
		return rh;
	}

	public String toString() {
		return name;
	}

	public String getMailAccount() {
		return mailAccount;
	}

	public void setMailAccount(String mailAccount) {
		this.mailAccount = mailAccount;
	}
	
	public Vector<Offer> getAllOffers (){
		Vector<Offer> offers = new Vector<Offer>();
		for(RuralHouse rh: this.ruralHouses){
			for(Offer of : rh.getAllOffers()){
			offers.add(of);
			}
		}
		return offers;
	}

}