package domain;

import java.io.Serializable;
import java.util.Date;

public class Booking implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int bookingNumber;
	private Date bookingDate;
	private Client client;
	private Offer offer;

	public Booking(int bN, Offer offer, Client client, Date date) {
		this.bookingNumber = bN;
		this.offer = offer;
		this.client = client;
		// Booking date is assigned to actual date
		this.bookingDate = date;
	}

	public Booking(int bN, Offer offer, Client client) {

		this.bookingNumber = bN;
		this.offer = offer;
		this.client = client;
		// Booking date is assigned to actual date
		this.bookingDate = new java.util.Date(System.currentTimeMillis());
	}

	public void imprimete() {
		System.out.println(bookingNumber);
		System.out.println(bookingDate);
		System.out.println(client.toString());
		System.out.println(offer);
	}

	public int getBookNumber() {
		return this.bookingNumber;
	}

	public void setOffer(Offer offer) {
		this.offer = offer;
	}

	public Offer getOffer() {
		return this.offer;
	}

	public float getPrice() {
		return this.offer.getPrice();
	}

	public void setBookDate(Date bookDate) {
		this.bookingDate = bookDate;
	}

	public Date getBookDate() {
		return this.bookingDate;
	}

	public Client getClient() {
		return client;
	}

	public void setClient(Client client) {
		this.client = client;
	}

}